<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Voucher ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Voucher extends AbstractStructArrayBase
{
    /**
     * The Voucher
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Voucher[]
     */
    public $Voucher;
    /**
     * Constructor method for ArrayOfJP_Voucher
     * @uses ArrayOfJP_Voucher::setVoucher()
     * @param \StructType\JP_Voucher[] $voucher
     */
    public function __construct(array $voucher = array())
    {
        $this
            ->setVoucher($voucher);
    }
    /**
     * Get Voucher value
     * @return \StructType\JP_Voucher[]|null
     */
    public function getVoucher()
    {
        return $this->Voucher;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucher method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucher method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherForArrayConstraintsFromSetVoucher(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_VoucherVoucherItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_VoucherVoucherItem instanceof \StructType\JP_Voucher) {
                $invalidValues[] = is_object($arrayOfJP_VoucherVoucherItem) ? get_class($arrayOfJP_VoucherVoucherItem) : sprintf('%s(%s)', gettype($arrayOfJP_VoucherVoucherItem), var_export($arrayOfJP_VoucherVoucherItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Voucher property can only contain items of type \StructType\JP_Voucher, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Voucher value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Voucher[] $voucher
     * @return \ArrayType\ArrayOfJP_Voucher
     */
    public function setVoucher(array $voucher = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherArrayErrorMessage = self::validateVoucherForArrayConstraintsFromSetVoucher($voucher))) {
            throw new \InvalidArgumentException($voucherArrayErrorMessage, __LINE__);
        }
        $this->Voucher = $voucher;
        return $this;
    }
    /**
     * Add item to Voucher value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Voucher $item
     * @return \ArrayType\ArrayOfJP_Voucher
     */
    public function addToVoucher(\StructType\JP_Voucher $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Voucher) {
            throw new \InvalidArgumentException(sprintf('The Voucher property can only contain items of type \StructType\JP_Voucher, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Voucher[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Voucher|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Voucher|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Voucher|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Voucher|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Voucher|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Voucher
     */
    public function getAttributeName()
    {
        return 'Voucher';
    }
}
